# teapot-spreadsheet

This project represents further development on <a href="https://www.syntax-k.de/projekte/teapot/">Teapot</a>, a three-dimensional, function-oriented spreadsheet with iterative updates, written by Michael Haardt and Jörg Walter, from V 2.3.0 posted 2012 Feb 6.

This is a development version following release 2.3.0 of teapot (Table Editor And Planner, Or: Teapot), a spread sheet program for UNIX.

	Copyright (C) 1995-2006 Michael Haardt
	Copyright (C) 2009-2012 Joerg Walter
	Copyright (C) 2019 Glen Whitney
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

The current release has the following features:

*  curses based user interface with easy to understand menus
*  FLTK 1.3 based GUI following common user interface conventions
*  Cross-platform compatibility
*  UTF-8 support
*  portable sheet file format uses XDR or ASCII format
*  tbl, LaTeX, HTML, CSV or formatted text files can be generated and simple SC and WK1 sheets can be imported
*  typed expression evaluator with the types int, float, string, error, pointer to cell and empty
*  iterative expressions
*  powerful cell addressing
*  three-dimensional sheets
*  new expression evaluator functions can be added very easy
*  a user guide, available as PDF and HTML
*  It is still a small and simple program!

teapot should work on any system which supports the following:

*  ANSI C
*  An XDR library (included in the GNU C library, otherwise use http://people.redhat.com/~rjones/portablexdr/ )
*  For the text interface: SYSV curses or ncurses library
*  For UTF-8 in the text interface: libncursesw and a UTF-8 locale
*  For the FLTK interface: C++
*  For the FLTK interface: FLTK 1.3

A GNU zipped tar file of the prior release V 2.3.0 is available from:

   http://www.syntax-k.de/projekte/teapot/

This development version is hosted at https://code.studioinfinity.org/glen/teapot-spreadsheet.

For more information, read the included manual in HTML or PDF format.

